#ifndef DEPTHLAYERTREEEMBEDDING__H
#define DEPTHLAYERTREEEMBEDDING__H

#include <torch/torch.h>
#include "fmt/core.h"
#include "LSTM.hpp"

class DepthLayerTreeEmbeddingImpl : public torch::nn::Module
{
  private :

  std::vector<LSTM> depthLstm;
  int maxDepth;
  int maxElemPerDepth;

  public :

  DepthLayerTreeEmbeddingImpl(int maxDepth, int maxElemPerDepth);
  torch::Tensor forward(torch::Tensor input);
  int getOutputSize();
};
TORCH_MODULE(DepthLayerTreeEmbedding);

#endif

